<?php

// display a message in the debug panel and in the debug file
function debug_mess($mess)
{
   global $dbg, $textfile, $debug_file;
   // debug message
   if ($dbg)
   {
      echo date("\[ d.m.y H:i:s\] ") . $mess . "<br>";
   }
	if (isset($debug_file))
	{
		// create a string to write to the debug file
		$str = date("\[ d.m.y H:i:s\] ") . $mess."\r\n";
		// write to file
        $textfile->add_string_to_file($debug_file, $str);
	}
}

// waiting for the loading of the element we need
function wait_on_element_by_text($tag, $text, $frme=-1, $wait=10, $pause=1)
{
  $a=0;

  while(!$tag->is_exist_by_inner_text($text, false, $frme))
  {   
     sleep($pause);
     if($a>$wait)
     {
        debug_mess("ERROR: did not wait for the desired element with text $text!");
       return false;   
     }

     $a++;
  }
   
  return true;   
}
// waiting for loading the element we need by attribute
function wait_on_element_by_att($tag, $att_name, $att_text, $frme=-1, $wait=10, $pause=1)
{
  $a=0;

  while(!$tag->is_exist_by_attribute($att_name, $att_text, false, $frme))
  {   
     sleep($pause);
     if($a>$wait)
     {
        debug_mess("ERROR: did not wait for the desired element with text $text!");
       return false;   
     }

     $a++;
  }
   
  return true;   
}

// waiting for the loading of the element we need
function wait_exists_element_by_text($tag, $text, $frme=-1, $wait=30, $pause=1)
{
  $a=0;

  while($tag->is_exist_by_inner_text($text, true, $frme))
  {   
     sleep($pause);
     if($a>$wait)
     {
       debug_mess("ERROR: element with text $text is still on the page! Waiting for $a seconds.");
       return false;   
     }

     $a++;
  }
   
  return true;   
}

// Delete duplicate words
function delete_duplicates_words($text)
{
    $text = implode(array_reverse(preg_split('//u', $text)));
    $text = preg_replace('/(\b[\pL0-9]++\b)(?=.*?\1)/siu', '', $text);
    $text = implode(array_reverse(preg_split('//u', $text)));
    return $text;
}

// get the frame number according to the text in it
function get_frame_number_by_text($tag, $text)
{
    for($i=0;$i<15;$i++)
    if($tag->is_exist_by_inner_text($text, false, $i))
      return $i;

 return -1;
}
// clear all information on the browser
function сlear_browser_info()
{
   global $browser;
   $browser->close_all_tabs();
    // navigate to blank page  
   $browser->navigate("about:blank");
   sleep(1);
   $browser->clear_cookies("");
   sleep(1);
   $browser->clear_cache();
   sleep(1); 

   return true;
}

// get string by prefixes
function get_string($str1, $pr1, $pr2, &$ind_st = 0)
{
	// get the starting index
	$ind1 = strpos($str1, $pr1, $ind_st);
	if($ind1 === false)
	{
		return "";
	}
	$ind1_1 = $ind1 + strlen($pr1);
	// get the finishing index
	$ind2 = strpos($str1, $pr2, $ind1_1);
	if ($ind2 === false)
	{
		return "";
	}
	// get result
	$sres = substr($str1, $ind1 + strlen($pr1), $ind2 - $ind1_1);
	return trim($sres); 
}

?>